%global modulename neutron_lbaas
%global servicename neutron-lbaas
%global type LBaaS

%global release_name liberty

%{!?upstream_version: %global upstream_version %{version}%{?milestone}}

# rpm macro to create fake tempest plugin entrypoint
%define py2_entrypoint() \
egg_path=%{buildroot}%{python2_sitelib}/%{1}-*.egg-info \
tempest_egg_path=%{buildroot}%{python2_sitelib}/%{1}_tests.egg-info \
mkdir $tempest_egg_path \
echo %{1} >$tempest_egg_path/top_level.txt \
grep "tempest\\|Tempest" %{1}.egg-info/entry_points.txt >$tempest_egg_path/entry_points.txt \
sed -i "/tempest\\|Tempest/d" $egg_path/entry_points.txt \
cp -r $egg_path/PKG-INFO $tempest_egg_path \
sed -i "s/%{2}/%{1}_tests/g" $tempest_egg_path/PKG-INFO \
%nil

Name:           openstack-%{servicename}
Version:        7.2.0
Release:        6%{?dist}
Epoch:          1
Summary:        Openstack Networking %{type} plugin

License:        ASL 2.0
URL:            http://launchpad.net/neutron/
Source0:        http://tarballs.openstack.org/%{servicename}/%{servicename}-%{upstream_version}.tar.gz
Source1:        %{servicename}-agent.service
Source2:        %{servicename}v2-agent.service
Source3:        %{servicename}-dist.conf

#
# patches_ignore=DROP-IN-RPM
# patches_base=+2
#
Patch0001: 0001-Rename-private_key-tests.patch
Patch0002: 0002-Skip-pylint-errors-in-radware-driver-modules.patch
Patch0003: 0003-Tests-helper-function-_send_requests-should-catch-so.patch
Patch0004: 0004-Preventing-pool-deletion-if-pool-has-healthmonitor.patch
Patch0005: 0005-Update-quota-tests-to-register-quota-resources.patch
Patch0006: 0006-Add-support-to-update-members-in-LBaaS-extension.patch
Patch0007: 0007-Fixed-upper-constraints-file-link.patch
Patch0008: 0008-apply-whitespace-changes-to-adapt-setup.cfg-from-rel.patch
Patch0009: 0009-Plugin-to-run-neutron-lbaas-tests-with-tempest.patch

BuildArch:      noarch
BuildRequires:  python2-devel
BuildRequires:  python-pbr
BuildRequires:  python-setuptools
BuildRequires:  systemd-units
BuildRequires:	git

Requires:       python-%{servicename} = %{epoch}:%{version}-%{release}
Requires:       openstack-neutron >= %{epoch}:%{version}

# This is not a hard dependency, but it's required by the default lbaas driver
Requires:       haproxy

%description
This is a %{type} service plugin for Openstack Neutron (Networking) service.


%package -n python-%{servicename}
Summary:        Neutron %{type} Python libraries
Group:          Applications/System

Requires:       python-neutron >= %{epoch}:%{version}
Requires:       python-alembic >= 0.7.2
Requires:       python-barbicanclient >= 3.0.1
Requires:       python-eventlet
Requires:       python-netaddr >= 0.7.12
Requires:       python-oslo-config >= 2:1.9.3
Requires:       python-oslo-db >= 1.7.0
Requires:       python-oslo-log >= 1.0.0
Requires:       python-oslo-messaging >= 1.8.0
Requires:       python-oslo-serialization >= 1.4.0
Requires:       python-oslo-utils >= 1.4.0
Requires:       python-pbr
Requires:       python-pyasn1
Requires:       python-pyasn1-modules
Requires:       python-requests
Requires:       python-six
Requires:       python-sqlalchemy >= 0.9.7
Requires:       pyOpenSSL


%description -n python-%{servicename}
This is a %{type} service plugin for Openstack Neutron (Networking) service.

This package contains the Neutron %{type} Python library.


%package -n python-%{servicename}-tests
Summary:        Neutron %{type} tests
Group:          Applications/System

Requires:       python-%{servicename} = %{epoch}:%{version}-%{release}


%description -n python-%{servicename}-tests
This is a %{type} service plugin for Openstack Neutron (Networking) service.

This package contains Neutron %{type} test files.


%prep
%autosetup -n %{servicename}-%{upstream_version} -S git

# Let's handle dependencies ourselves
rm -f requirements.txt

# Kill egg-info in order to generate new SOURCES.txt
rm -rf neutron_lbaas.egg-info

%build
export PBR_VERSION=%{version}
export SKIP_PIP_INSTALL=1
%{__python2} setup.py build

# Loop through values in neutron-lbaas-dist.conf and make sure that the values
# are substituted into the lbaas_agent.ini as comments.
while read name eq value; do
  if [ -n "$name" -a -n "$value" ]; then
    sed -ri "0,/^(#)? *$name *=/{s!\(^(#)? *$name *=\).*!\1 $value!}" etc/lbaas_agent.ini
  fi
done < %{SOURCE3}


%install
export PBR_VERSION=%{version}
export SKIP_PIP_INSTALL=1
%{__python2} setup.py install -O1 --skip-build --root %{buildroot}

# Move rootwrap files to proper location
install -d -m 755 %{buildroot}%{_datarootdir}/neutron/rootwrap
mv %{buildroot}/usr/etc/neutron/rootwrap.d/*.filters %{buildroot}%{_datarootdir}/neutron/rootwrap

# Move config files to proper location
install -d -m 755 %{buildroot}%{_sysconfdir}/neutron
mv %{buildroot}/usr/etc/neutron/*.ini %{buildroot}%{_sysconfdir}/neutron
mv %{buildroot}/usr/etc/neutron/*.conf %{buildroot}%{_sysconfdir}/neutron

# Install systemd units
install -p -D -m 644 %{SOURCE1} %{buildroot}%{_unitdir}/%{servicename}-agent.service
install -p -D -m 644 %{SOURCE2} %{buildroot}%{_unitdir}/%{servicename}v2-agent.service

# Install dist conf
install -p -D -m 640 %{SOURCE3} %{buildroot}%{_datadir}/neutron/%{servicename}-dist.conf

# Create configuration directories that can be populated by users with custom *.conf files
mkdir -p %{buildroot}/%{_sysconfdir}/neutron/conf.d/%{servicename}-agent
mkdir -p %{buildroot}/%{_sysconfdir}/neutron/conf.d/%{servicename}v2-agent

# Make sure neutron-server loads new configuration file
mkdir -p %{buildroot}/%{_datadir}/neutron/server
ln -s %{_sysconfdir}/neutron/%{modulename}.conf %{buildroot}%{_datadir}/neutron/server/%{modulename}.conf

%py2_entrypoint %{modulename} %{servicename}

%post
%systemd_post %{servicename}-agent.service
%systemd_post %{servicename}v2-agent.service


%preun
%systemd_preun %{servicename}-agent.service
%systemd_preun %{servicename}v2-agent.service


%postun
%systemd_postun_with_restart %{servicename}-agent.service
%systemd_postun_with_restart %{servicename}v2-agent.service


%files
%license LICENSE
%doc AUTHORS CONTRIBUTING.rst README.rst
%{_bindir}/%{servicename}-agent
%{_bindir}/%{servicename}v2-agent
%{_unitdir}/%{servicename}-agent.service
%{_unitdir}/%{servicename}v2-agent.service
%{_datarootdir}/neutron/rootwrap/lbaas-haproxy.filters
%config(noreplace) %attr(0640, root, neutron) %{_sysconfdir}/neutron/lbaas_agent.ini
%config(noreplace) %attr(0640, root, neutron) %{_sysconfdir}/neutron/neutron_lbaas.conf
%config(noreplace) %attr(0640, root, neutron) %{_sysconfdir}/neutron/services_lbaas.conf
%dir %{_sysconfdir}/neutron/conf.d
%dir %{_sysconfdir}/neutron/conf.d/%{servicename}-agent
%dir %{_sysconfdir}/neutron/conf.d/%{servicename}v2-agent
%attr(-, root, neutron) %{_datadir}/neutron/%{servicename}-dist.conf
%{_datadir}/neutron/server/%{modulename}.conf


%files -n python-%{servicename}
%{python2_sitelib}/%{modulename}
%{python2_sitelib}/%{modulename}-%{version}-py%{python2_version}.egg-info
%exclude %{python2_sitelib}/%{modulename}/tests


%files -n python-%{servicename}-tests
%{python2_sitelib}/%{modulename}/tests
%{python2_sitelib}/%{modulename}_tests.egg-info


%changelog
* Thu Feb 22 2018 Chandan Kumar <chkumar@redhat.com> 1:7.0.2-6
- Added macro to create tempest plugin fake entrypoint

* Mon Dec 25 2017 Nir Magnezi <nmagnezi@redhat.com> 1:7.2.0-5
- Plugin to run neutron-lbaas tests with tempest (rhbz#1526100)
- apply whitespace changes to adapt setup.cfg from release tarball (rhbz#1526100)
- Fixed upper constraints file link

* Thu Aug 24 2017 Nir Magnezi <nmagnezi@redhat.com> 1:7.2.0-4
- Add support to update members in LBaaS extension (rhbz#1482671)
- Update quota tests to register quota resources (rhbz#1482671)

* Thu Jun 22 2017 Assaf Muller <amuller@redhat.com> 1:7.2.0-3
- Preventing pool deletion if pool has healthmonitor (rhbz#1452571)
- Tests helper function _send_requests should catch socket.error (rhbz#1450675)

* Tue Apr 25 2017 Nir Magnezi <nmagnezi@redhat.com> 1:7.2.0-2
- Tests helper function _send_requests should catch socket.error (rhbz#1450675)
- Add haproxy as a dependency for haproxy (rhbz#1339260)

* Sun Nov 06 2016 Nir Magnezi <nmagnezi@redhat.com> 1:7.2.0-1
- Update to 7.2.0, rhbz#1390622

* Tue Jul 12 2016 Nir Magnezi <nmagnezi@redhat.com> 1:7.1.1-1
- Update to 7.1.1, rhbz#1350451

* Mon Nov 09 2015 Ihar Hrachyshka <ihrachys@redhat.com> 1:7.0.0-2.el7
- Skip pylint errors in radware driver modules
- Rename private_key tests

* Tue Oct 20 2015 Alan Pevec <alan.pevec@redhat.com> 1:7.0.0-1
- Update to 7.0.0

* Mon Oct 12 2015 Alan Pevec <alan.pevec@redhat.com> 1:7.0.0-0.3.0rc2
- Update to upstream 7.0.0.0rc2

* Thu Oct 01 2015 Ihar Hrachyshka <ihrachys@redhat.com> 1:7.0.0-0.2.0rc1.el7
- Update to upstream 7.0.0.0rc1

* Wed Sep 16 2015 Ihar Hrachyshka <ihrachys@redhat.com> 1:7.0.0-0.1.0b3.el7
- Initial release for Liberty M3.
